<?php
/*
Plugin Name: zed1.com Team Fixture Widget
Plugin URI: http://zed1.com/journalized/zed1-fixtures
Description: Display team fixture with date and badges. Another <a href="http://zed1.com/">zed1.com</a> WordPress plugin.
Author: Mike Little
Version: 1.0.7
Author URI: http://zed1.com/
*/

/*  Copyright 2008  Mike Little  (email : mike@zed1.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// control panel for widget
function zed1_fix_control() {
    $options = get_option("widget_zed1_fix");
    if (!is_array($options)) {
        $options = array('title' => 'Next Match');
    }
    if (!isset($options['badges_folder'])) {
        $options['badges_folder'] = get_default_badges_folder();
    }
    if ($_POST['zed1_fix_submit']) {
        $options['title'] = htmlspecialchars($_POST['zed1_fix_widget_title']);
        $options['date'] = htmlspecialchars($_POST['zed1_fix_widget_date']);
        $options['time'] = htmlspecialchars($_POST['zed1_fix_widget_time']);
        $options['competition'] = htmlspecialchars($_POST['zed1_fix_widget_competition']);
        $options['home_team'] = htmlspecialchars($_POST['zed1_fix_widget_home']);
        $options['away_team'] = htmlspecialchars($_POST['zed1_fix_widget_away']);
        $options['tvlogo'] = htmlspecialchars($_POST['zed1_fix_widget_tvlogo']);
        //$options['badges_folder'] = htmlspecialchars($_POST['zed1_fix_widget_folder']);
        $options['badges_folder'] = get_default_badges_folder();
        $options['tvlogo_folder'] = get_default_tvlogo_folder();
        update_option("widget_zed1_fix", $options);
    }

  $options_home = '<option value="">-- Chose Team --</option>'."\n";
  $options_away = '<option value="">-- Chose Team --</option>'."\n";
  $list = get_badge_list();
  foreach($list as $group => $sub) {
      $options_home .= '<optgroup label="'.$group.'">';
      $options_away .= '<optgroup label="'.$group.'">';
      foreach($sub as $team => $badge) {
          if (($team . '#' . $badge) == $options['home_team']) {
              $selected = ' selected="selected"';
          } else {
              $selected = '';
          }
          $options_home .= '<option value="' . $team . '#' . $badge . '"'. $selected .'>' .  $team . '</option>'."\n";
          if (($team . '#' . $badge) == $options['away_team']) {
              $selected = ' selected="selected"';
          } else {
              $selected = '';
          }
          $options_away .= '<option value="' . $team . '#' . $badge . '"' . $selected . '>' .  $team . '</option>'."\n";
      }
      $options_home .= '</optgroup>';
      $options_away .= '</optgroup>';

  }

  $options_tvlogo = '<option value="">-- Chose TV Channel --</option>'."\n";
  $list = get_tvlogo_list();
  foreach($list as $tv => $logo) {
      if (($tv . '#' . $logo) == $options['tvlogo']) {
          $selected = ' selected="selected"';
      } else {
          $selected = '';
      }
      $options_tvlogo .= '<option value="' . $tv . '#' . $logo . '"' . $selected . '>' .  $tv . '</option>'."\n";
  }

?>
  <p>
    <label for="zed1_fix_widget_title">Widget Title: </label>
    <input type="text" class="widefat" id="zed1_fix_widget_title" name="zed1_fix_widget_title" value="<?php echo $options['title'];?>" />
  </p>
  <p>
    <label for="zed1_fix_widget_date">Fixture Date: </label>
    <input type="text" class="widefat" id="zed1_fix_widget_date" name="zed1_fix_widget_date" value="<?php echo $options['date'];?>" />
  </p>
  <p>
    <label for="zed1_fix_widget_time">Kickoff Time: </label>
    <input type="text" class="widefat" id="zed1_fix_widget_time" name="zed1_fix_widget_time" value="<?php echo $options['time'];?>" />
  </p>
  <p>
    <label for="zed1_fix_widget_competition">Competition: </label>
    <input type="text" class="widefat" id="zed1_fix_widget_competition" name="zed1_fix_widget_competition" value="<?php echo $options['competition'];?>" />
  </p>
  <p>
    <label for="zed1_fix_widget_tvlogo">TV Channel: </label>
    <select class="widefat" id="zed1_fix_widget_tvlogo" name="zed1_fix_widget_tvlogo">
      <?php echo $options_tvlogo; ?>
      </select><!-- $options['tvlogo'] -->
  </p>
  <p>
    <label for="zed1_fix_widget_home">Home Team: </label>
    <select class="widefat" id="zed1_fix_widget_home" name="zed1_fix_widget_home">
      <?php echo $options_home; ?>
      </select><!-- $options['home_team'] -->
  </p>
  <p>VS.</p>
  <p>
    <label for="zed1_fix_widget_away">Away Team: </label>
    <select class="widefat" id="zed1_fix_widget_away" name="zed1_fix_widget_away">
      <?php echo $options_away; ?>
      </select><!-- $options['away_team'] -->
  </p>
  <p>
    <input type="hidden" id="zed1_fix_submit" name="zed1_fix_submit" value="1" />
  </p>
<?php
} // end zed1_fix_control

function get_tvlogo_list() {
    $options = get_option("widget_zed1_fix");
    if (!isset($options['tvlogo_folder'])) {
        $options['tvlogo_folder'] = get_default_tvlogo_folder();
    }
    extract($options);

    $list = null;

    if (0 && class_exists('RecursiveDirectoryIterator')) {
        $list = get_imagefilelist($tvlogo_folder, $tvlogo_folder, false);
    } else { // use old scholl recursive func
        $list = directoryToArray($tvlogo_folder, $tvlogo_folder, true, false);
    }

    //echo count($list);
    if (null != $list)
        ksort($list);
    return $list;
}
function get_badge_list() {
    $options = get_option("widget_zed1_fix");
    if (!isset($options['badges_folder'])) {
        $options['badges_folder'] = get_default_badges_folder();
    }
    extract($options);

    $list = null;

    if (0 && class_exists('RecursiveDirectoryIterator')) {
        $list = get_imagefilelist($badges_folder, $badges_folder);
    } else { // use old scholl recursive func
        $list = directoryToArray($badges_folder, $badges_folder, true, true);
    }

    //echo count($list);
    if (null != $list) {
        ksort($list);
        if (count($list) > 1) {
            foreach (array_keys($list) as $k) {
                if (is_array($list[$k])) {
                    ksort($list[$k]);
                }
            }
        }
    }
    return $list;
} // end get_badge_list

function get_imagefilelist($original_directory, $directory, $multi = true) {
    $dir = new RecursiveDirectoryIterator($directory.'/');
    foreach (new RecursiveIteratorIterator($dir) as $file) {
        if (preg_match('@\.(jpg)|(png)|(gif)$@i', $file-> getFilename())
              && !preg_match('@\.svn@i', $file-> getFilename())) {
            // get the filename, change '_' to ' ', then use as the key to store the relative file path against.

            $filename = $file-> getFilename();
            if (preg_match('@\.png$@i', $file)){
                $filename = basename($filename, '.png');
            } else if (preg_match('@\.jpg$@i', $file)){
                $filename = basename($filename, '.jpg');
            } else if (preg_match('@\.gif$@i', $file)){
                $filename = basename($filename, '.gif');
            }
            $filename = str_replace('_', ' ', $filename);
            $pathname = str_replace($original_directory, '', $file-> getPathname());
            $output .=  "pathname -> $pathname\n";
            if ($multi) {
                list($ignore, $firstlevelpathname, $ignore) = split('/', $pathname);
                $firstlevelpathname = str_replace('_', ' ', $firstlevelpathname);
                $output .=  "firstlevelpathname -> $firstlevelpathname\n";
                $list[$firstlevelpathname][$filename] = $pathname;
            } else {
                $list[$filename] = $pathname;
            }
            //$list[$filename] = $pathname;
            $output .=  "$filename -> $pathname\n";
        }
    }
    //echo ("<pre>$output</pre>");
    return $list;
}
    
function directoryToArray($original_directory, $directory, $recursive, $multi = true) {
	$array_items = array();
	if ($handle = opendir($directory)) {
		while (false !== ($file = readdir($handle))) {
			if ($file != "." && $file != ".." && $file != ".svn") {
				if (is_dir($directory. "/" . $file)) {
					if($recursive) {
						$array_items = array_merge($array_items, directoryToArray($original_directory, $directory. "/" . $file, $recursive, $multi));
					}
                } else if (preg_match('@\.(jpg)|(png)|(gif)$@i', $file)){

                    $filename = $file;
                    if (preg_match('@\.png$@i', $file)){
                        $filename = basename($filename, '.png');
                    } else if (preg_match('@\.jpg$@i', $file)){
                        $filename = basename($filename, '.jpg');
                    } else if (preg_match('@\.gif$@i', $file)){
                        $filename = basename($filename, '.gif');
                    }
                    $filename = str_replace('_', ' ', $filename);
					$pathname = $directory . "/" . $file;
                    
                    $pathname = str_replace($original_directory, '', $pathname);
                    $output .=  "pathname -> $pathname\n";
                    if ($multi) {
                        list($ignore, $firstlevelpathname, $ignore) = split('/', $pathname);
                        $firstlevelpathname = str_replace('_', ' ', $firstlevelpathname);
                        $output .=  "firstlevelpathname -> $firstlevelpathname\n";
                        $array_items[$firstlevelpathname][$filename] = $pathname;
                    } else {
                        $array_items[$filename] = $pathname;
                    }
                    $output .=  "$filename -> $pathname\n";

					//$array_items[] = preg_replace("/\/\//si", "/", $file);
                    
				} // end else file
			} // end if not dots
		} // end while readdir
		closedir($handle);
	}
    //echo count($list);
    //echo ("<pre>$output</pre>");
	return $array_items;
}
    
function get_default_badges_folder() {
    return str_replace('\\', '/', dirname(__FILE__) . '/badges');           
} // end get_default_badges_folder

function get_default_badges_url() {
    $abs = str_replace('\\', '/', ABSPATH);
    $path =  get_default_badges_folder();
    $url = str_replace($abs, get_settings('siteurl').'/', $path);
    return $url;
} // end get_default_badges_folder

function get_default_tvlogo_folder() {
    return str_replace('\\', '/', dirname(__FILE__) . '/tvlogos');           
} // end get_default_tvlogo_folder

function get_default_tvlogo_url() {
    $abs = str_replace('\\', '/', ABSPATH);
    $path =  get_default_tvlogo_folder();
    $url = str_replace($abs, get_settings('siteurl').'/', $path);
    return $url;
} // end get_default_tvlogo_folder


// Do the actual widget work
function zed1_fix() {
    $options = get_option("widget_zed1_fix");
    $title = $options['title']; // NUX Upcoming Events
    list($home_team, $home_badge) = split('#', $options['home_team']);
    list($away_team, $away_badge) = split('#', $options['away_team']);
    list($tv, $logo)              = split('#', $options['tvlogo']);

    echo '<div class="fixture">' . "\n";
    echo '<p class="teams"><img src="'. get_default_badges_url()  . $home_badge . '" alt="'.$home_team.' badge" />' . "";
    echo '<span class="versus">VS</span>' . "\n";
    echo '<img src="'. get_default_badges_url()  . $away_badge . '" alt="'.$away_team.' badge" /></p>' . "\n";
    if (isset($options['competition'])) {
        echo '<p class="fixture_comp">' . $options['competition'] . "</p>\n";
    }
    echo '<p class="fixture_date">' . $options['date'] . "<br />\n";
    if (isset($options['time'])) {
        echo 'Time: ' . $options['time'] . "<br />\n";
    }
    if (isset($logo)) {
        echo '<img src="'. get_default_tvlogo_url()  . $logo . '" alt="TV channel '.$tv.'" /></p>' . "\n";
    }
    //echo '<p class="fixture_desc">' .$home_team . ' vs. ' . $away_team . '</span></p>' . "\n";
    echo '</div>';

} // end zed1_fix

// widget function called by template
function widget_zed1_fix($args) {
    extract($args);

    $options = get_option("widget_zed1_fix");
    if (!is_array( $options )) {
        $options = array('title' => 'Next Fixture');
    }

    echo $before_widget;
    echo $before_title;
    echo $options['title'];
    echo $after_title;
    if (!is_admin())
        zed1_fix();
    echo $after_widget;
} // end widget_zed1_fix

function zed1_fix_css() {
?>
<style type="text/css">
/* zed1 team fixture */

.fixture {
  text-align: center;
}

.fixture img {
  vertical-align: middle;
}

.teams {
  text-align: center;
  margin-bottom: 1.5em;
}
.versus {
  font-size: 180%;
  font-weight: bold;
  margin: auto 0.5em;
}

.fixture_comp {
  font-size: 150%;
  text-align: center;
  margin-top: 1.5em;
  
}
.fixture_date {
  font-size: 120%;
  text-align: center;
  line-height: 1.5;
}

.fixture_desc {
  font-size: 130%;
  margin: 0.5em;
}

</style>
<?php
} // end zed1_fix_css

function zed1_fix_init() {
  register_sidebar_widget(__('Team Fixture'), 'widget_zed1_fix');
  register_widget_control(   'Team Fixture', 'zed1_fix_control', null, 200 );
} // end zed1_fix_init

add_action("plugins_loaded", "zed1_fix_init");
add_action("wp_head" , "zed1_fix_css");
?>
